(load "pmonad.scm")

; useful subprogram: a coin flip
(define
  (flip p)
  (p_choose p
	    (p_return #t)
	    (p_return #f)))

; the traditional "alarm" network
(define x
 (p_then
  (flip 0.002)
  (lambda (earthquake)
 (p_then
  (flip 0.001)
  (lambda (burglary)
 (p_then
  (if (f earthquake)
    (if (f burglary) (flip 0.95) (flip 0.29))
    (if (f burglary) (flip 0.94) (flip 0.001)))
  (lambda (alarm)
 (p_then
  (p_then alarm
   (lambda (a) (if (f a) (flip 0.9) (flip 0.05))))
  (lambda (john)
 (p_then  
  (p_then alarm
	  (lambda (a) (if (f a) (flip 0.7) (flip 0.01))))
  (lambda (mary)
   (p_observe
    (f alarm)
    (p_return earthquake)))))))))))))

; compute the distribution
(dist x)

